To create a RangeTemplate , follow this example:
The following is the API definition:
The parameters row, col, rowCount, and colCount are optional. If those parameters not set, the whole sheet row will be used to create the RangeTemplate. Here is an example of creating a RangeTemplate with a defined row and column count:
You can customize your bindingPath or formula in the template WorkSheet. The RangeTemplate will then use the cell value as the datasource to resolve the bindingPath or formula in the designated range.
Conditional rules, data validation, sparkline data & date ranges, sparklineEx, and formulas can refer to a cell or cell range and they must be contained within the RangeTemplate. In addition, the spans in template WorkSheet must be completely contained inside the RangeTemplate.
The RangeTemplate does not support nesting other RangeTemplates, as it may lose data or cause an endless loop.
window.onload = function () {
var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), { sheetCount: 1 });
initSpread(spread);
};
function bindEvent(renderSheet, templateSheet) {
document.getElementById("update").onclick = function () {
var celltype = new GC.Spread.Sheets.CellTypes.RangeTemplate(templateSheet);
renderSheet.setCellType(-1, 0, celltype);
};
}
function initSpread(spread) {
var renderSheet = spread.getActiveSheet();
var templateSheet = new GC.Spread.Sheets.Worksheet();
templateSheet.fromJSON(templatesheetjson);
spread.addSheet(1,templateSheet);
templateSheet.setFormatter(2,2,"=IMAGE(@)");
bindEvent(renderSheet, templateSheet);
renderSheet.suspendPaint();
var celltype = new GC.Spread.Sheets.CellTypes.RangeTemplate(templateSheet);
renderSheet.autoGenerateColumns = false;
renderSheet.setDataSource(data);
var cardInfo = {
displayName: "Person Card",
size: 440,
value: function (item) {
return item;
},
cellType: celltype
};
renderSheet.defaults.rowHeight = 207;
renderSheet.bindColumn(0, cardInfo);
renderSheet.bindColumn(1, { displayName: "Name", name: 'fullName', size: 150 });
renderSheet.bindColumn(2, { displayName: "Phone", name: 'phone', size: 150 });
renderSheet.bindColumn(3, { displayName: "Email", name: 'email', size: 360 });
renderSheet.bindColumn(4, { displayName: "Registered Date", name: 'registered.date', size: 240 });
renderSheet.resumePaint();
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@grapecity/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/purejs/node_modules/@grapecity/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/data/rangecelltype-data.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/data/rangecelltype-templatesheet.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets"></div>
<div class="options-container">
<div class="option-row">
<p>In this example, you can change the template label text. Switch to the Template sheet, change the Email or Phone text, then press Update RangeTemplate to apply your changes to the template. You can switch back to Sheet1 to view your changes.</p>
<input type="button" id="update" value="Update RangeTemplate"/>
</div>
</div>
</div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
overflow: auto;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
}
.option-row {
padding-bottom: 8px;
}
label {
padding-bottom: 4px;
display: block;
}
input {
width: 100%;
padding: 4px 8px;
box-sizing: border-box;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}

To create a RangeTemplate , follow this example:
The following is the API definition:
The parameters row, col, rowCount, and colCount are optional. If those parameters not set, the whole sheet row will be used to create the RangeTemplate. Here is an example of creating a RangeTemplate with a defined row and column count:
You can customize your bindingPath or formula in the template WorkSheet. The RangeTemplate will then use the cell value as the datasource to resolve the bindingPath or formula in the designated range.
Conditional rules, data validation, sparkline data & date ranges, sparklineEx, and formulas can refer to a cell or cell range and they must be contained within the RangeTemplate. In addition, the spans in template WorkSheet must be completely contained inside the RangeTemplate.
The RangeTemplate does not support nesting other RangeTemplates, as it may lose data or cause an endless loop.
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
<p>In this example, you can change the template label text. Switch to the Template sheet, change the Email or
Phone text, then press Update RangeTemplate to apply your changes to the template. You can switch back to
Sheet1 to view your changes.</p>
<input type="button" id="update" value="Update RangeTemplate" v-on:click="updateRangeCelltype" />
</div>
</div>
</div>
</template>
<script setup>
import '@mescius/spread-sheets-vue'
import { ref, computed } from "vue";
import GC from "@mescius/spread-sheets";
const spreadRef = ref(null);
const templateSheetRef = ref(null);
const renderSheetRef = ref(null);
function updateRangeCelltype() {
let celltype = new GC.Spread.Sheets.CellTypes.RangeTemplate(templateSheetRef.value);
renderSheetRef.value.setCellType(-1, 0, celltype);
}
function initSpread(spread) {
spreadRef.value = spread;
spread.setSheetCount(1);
let renderSheet = spread.getActiveSheet();
let templateSheet = new GC.Spread.Sheets.Worksheet();
templateSheet.fromJSON(templatesheetjson);
spread.addSheet(1, templateSheet);
templateSheetRef.value = templateSheet;
renderSheetRef.value = renderSheet;
renderSheet.suspendPaint();
let celltype = new GC.Spread.Sheets.CellTypes.RangeTemplate(templateSheet);
renderSheet.autoGenerateColumns = false;
data = updateData(renderSheet, data)
renderSheet.setDataSource(data);
let cardInfo = {
displayName: "Person Card",
size: 440,
value: function (item) {
return item;
},
cellType: celltype
};
renderSheet.defaults.rowHeight = 207;
renderSheet.bindColumn(0, cardInfo);
renderSheet.bindColumn(1, { displayName: "Name", name: 'fullName', size: 150 });
renderSheet.bindColumn(2, { displayName: "Phone", name: 'phone', size: 150 });
renderSheet.bindColumn(3, { displayName: "Email", name: 'email', size: 360 });
renderSheet.bindColumn(4, { displayName: "Registered Date", name: 'registered.date', size: 240 });
renderSheet.resumePaint();
}
function updateData(sheet, data) {
data.forEach(obj => {
var url = obj.image;
obj.image = GC.Spread.Sheets.CalcEngine.evaluateFormula(sheet, '=IMAGE(\"' + url + '\")');
});
return data;
}
</script>
<style scoped>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
overflow: auto;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
}
.option-row {
padding-bottom: 8px;
}
label {
padding-bottom: 4px;
display: block;
}
input {
width: 100%;
padding: 4px 8px;
box-sizing: border-box;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/rangecelltype-data.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/data/rangecelltype-templatesheet.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app" style="height: 100%;"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.2-master-2026-06-10-2131/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-vue': 'cdn:@mescius/spread-sheets-vue/index.js',
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

To create a RangeTemplate , follow this example:
The following is the API definition:
The parameters row, col, rowCount, and colCount are optional. If those parameters not set, the whole sheet row will be used to create the RangeTemplate. Here is an example of creating a RangeTemplate with a defined row and column count:
You can customize your bindingPath or formula in the template WorkSheet. The RangeTemplate will then use the cell value as the datasource to resolve the bindingPath or formula in the designated range.
Conditional rules, data validation, sparkline data & date ranges, sparklineEx, and formulas can refer to a cell or cell range and they must be contained within the RangeTemplate. In addition, the spans in template WorkSheet must be completely contained inside the RangeTemplate.
The RangeTemplate does not support nesting other RangeTemplates, as it may lose data or cause an endless loop.
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
renderSheet: GC.Spread.Sheets.Worksheet;
templateSheet: GC.Spread.Sheets.Worksheet;
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
updateRangeCelltype() {
let celltype = new GC.Spread.Sheets.CellTypes.RangeTemplate(this.templateSheet);
this.renderSheet.setCellType(-1, 0, celltype);
}
initSpread($event: any) {
this.spread = $event.spread;
let spread = this.spread;
spread.setSheetCount(1);
let renderSheet = spread.getActiveSheet();
let templateSheet = new GC.Spread.Sheets.Worksheet();
templateSheet.fromJSON(templatesheetjson);
spread.addSheet(1, templateSheet);
this.templateSheet = templateSheet;
this.renderSheet = renderSheet;
renderSheet.suspendPaint();
let celltype = new GC.Spread.Sheets.CellTypes.RangeTemplate(templateSheet);
renderSheet.autoGenerateColumns = false;
data = this.updateData(renderSheet,data);
renderSheet.setDataSource(data);
let cardInfo = {
displayName: "Person Card",
size: 440,
value: function (item: any) {
return item;
},
cellType: celltype
};
renderSheet.defaults.rowHeight = 207;
renderSheet.bindColumn(0, cardInfo);
renderSheet.bindColumn(1, { displayName: "Name", name: 'fullName', size: 150 });
renderSheet.bindColumn(2, { displayName: "Phone", name: 'phone', size: 150 });
renderSheet.bindColumn(3, { displayName: "Email", name: 'email', size: 360 });
renderSheet.bindColumn(4, { displayName: "Registered Date", name: 'registered.date', size: 240 });
renderSheet.resumePaint();
}
updateData(sheet:GC.Spread.Sheets.worksheet, data:any[]) {
data.forEach(obj => {
var url = obj.image;
obj.image = GC.Spread.Sheets.CalcEngine.evaluateFormula(sheet, '=IMAGE(\"' + url + '\")');
});
return data;
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule {}
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<script src="$DEMOROOT$/spread/source/data/rangecelltype-data.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/data/rangecelltype-templatesheet.js" type="text/javascript"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
<p>In this example, you can change the template label text. Switch to the Template sheet, change the Email or Phone text, then press Update RangeTemplate to apply your changes to the template. You can switch back to Sheet1 to view your changes.</p>
<input type="button" id="update" value="Update RangeTemplate" (click) = "updateRangeCelltype($event)"/>
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
overflow: auto;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
}
.option-row {
padding-bottom: 8px;
}
label {
padding-bottom: 4px;
display: block;
}
input {
width: 100%;
padding: 4px 8px;
box-sizing: border-box;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.2-master-2026-06-10-2131/'
},
// map tells the System loader where to look for things
map: {
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'cdn:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

To create a RangeTemplate , follow this example:
The following is the API definition:
The parameters row, col, rowCount, and colCount are optional. If those parameters not set, the whole sheet row will be used to create the RangeTemplate. Here is an example of creating a RangeTemplate with a defined row and column count:
You can customize your bindingPath or formula in the template WorkSheet. The RangeTemplate will then use the cell value as the datasource to resolve the bindingPath or formula in the designated range.
Conditional rules, data validation, sparkline data & date ranges, sparklineEx, and formulas can refer to a cell or cell range and they must be contained within the RangeTemplate. In addition, the spans in template WorkSheet must be completely contained inside the RangeTemplate.
The RangeTemplate does not support nesting other RangeTemplates, as it may lose data or cause an endless loop.
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
// import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
// createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets } from '@mescius/spread-sheets-react';
export function AppFunc() {
let spread = null;
let renderSheet = null;
let templateSheet = null;
const updateRangeCellType = () => {
let celltype = new GC.Spread.Sheets.CellTypes.RangeTemplate(templateSheet);
renderSheet.setCellType(-1, 0, celltype);
}
const initSpread = (currSpread) => {
spread = currSpread;
spread.setSheetCount(1);
let renderSheet = spread.getActiveSheet();
let templateSheet = new GC.Spread.Sheets.Worksheet();
templateSheet.fromJSON(templatesheetjson);
spread.addSheet(1,templateSheet);
templateSheet = templateSheet;
renderSheet = renderSheet;
renderSheet.suspendPaint();
let celltype = new GC.Spread.Sheets.CellTypes.RangeTemplate(templateSheet);
renderSheet.autoGenerateColumns = false;
data = updateData(renderSheet, data);
renderSheet.setDataSource(data);
let cardInfo = {
displayName: "Person Card",
size: 440,
value: function (item) {
return item;
},
cellType: celltype
};
renderSheet.defaults.rowHeight = 207;
renderSheet.bindColumn(0, cardInfo);
renderSheet.bindColumn(1, { displayName: "Name", name: 'fullName', size: 150 });
renderSheet.bindColumn(2, { displayName: "Phone", name: 'phone', size: 150 });
renderSheet.bindColumn(3, { displayName: "Email", name: 'email', size: 360 });
renderSheet.bindColumn(4, { displayName: "Registered Date", name: 'registered.date', size: 240 });
renderSheet.resumePaint();
}
const updateData = (sheet, data) => {
data.forEach(obj => {
var url = obj.image;
obj.image = GC.Spread.Sheets.CalcEngine.evaluateFormula(sheet, '=IMAGE(\"' + url + '\")');
});
return data;
}
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={initSpread}>
</SpreadSheets>
</div>
<Panel updateRangeCellType={updateRangeCellType}/>
</div>
);
}
function Panel(props) {
return(
<div class="options-container">
<div class="option-row">
<p>In this example, you can change the template label text. Switch to the Template sheet, change the Email or Phone text, then press Update RangeTemplate to apply your changes to the template. You can switch back to Sheet1 to view your changes.</p>
<input type="button" id="update" value="Update RangeTemplate" onClick = {props.updateRangeCellType}/>
</div>
</div>
);
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets } from '@mescius/spread-sheets-react';
const Component = React.Component;
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.updateRangeCelltype = this.updateRangeCelltype.bind(this);
this.renderSheet = null;
this.templateSheet = null;
}
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread=>this.initSpread(spread)}>
</SpreadSheets>
</div>
<Panel updateRangeCelltype={(e)=>{this.updateRangeCelltype(e)}}/>
</div>
)
}
updateRangeCelltype() {
let celltype = new GC.Spread.Sheets.CellTypes.RangeTemplate(this.templateSheet);
this.renderSheet.setCellType(0, 0, celltype);
}
initSpread(spread) {
this.spread = spread;
spread.setSheetCount(1);
let renderSheet = spread.getActiveSheet();
let templateSheet = new GC.Spread.Sheets.Worksheet();
templateSheet.fromJSON(templatesheetjson);
spread.addSheet(1,templateSheet);
this.templateSheet = templateSheet;
this.renderSheet = renderSheet;
renderSheet.suspendPaint();
let celltype = new GC.Spread.Sheets.CellTypes.RangeTemplate(templateSheet);
renderSheet.autoGenerateColumns = false;
data = this.updateData(renderSheet, data);
renderSheet.setDataSource(data);
let cardInfo = {
displayName: "Person Card",
size: 440,
value: function (item) {
return item;
},
cellType: celltype
};
renderSheet.defaults.rowHeight = 207;
renderSheet.bindColumn(0, cardInfo);
renderSheet.bindColumn(1, { displayName: "Name", name: 'fullName', size: 150 });
renderSheet.bindColumn(2, { displayName: "Phone", name: 'phone', size: 150 });
renderSheet.bindColumn(3, { displayName: "Email", name: 'email', size: 360 });
renderSheet.bindColumn(4, { displayName: "Registered Date", name: 'registered.date', size: 240 });
renderSheet.resumePaint();
}
updateData(sheet, data) {
data.forEach(obj => {
var url = obj.image;
obj.image = GC.Spread.Sheets.CalcEngine.evaluateFormula(sheet, '=IMAGE(\"' + url + '\")');
});
return data;
}
}
class Panel extends Component{
constructor(props){
super(props);
}
render(){
return(
<div class="options-container">
<div class="option-row">
<p>In this example, you can change the template label text. Switch to the Template sheet, change the Email or Phone text, then press Update RangeTemplate to apply your changes to the template. You can switch back to Sheet1 to view your changes.</p>
<input type="button" id="update" value="Update RangeTemplate" onClick = {() => {this.props.updateRangeCelltype()}}/>
</div>
</div>
)
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/rangecelltype-data.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/data/rangecelltype-templatesheet.js" type="text/javascript"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app" style="height: 100%;"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
overflow: auto;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
}
.option-row {
padding-bottom: 8px;
}
label {
padding-bottom: 4px;
display: block;
}
input {
width: 100%;
padding: 4px 8px;
box-sizing: border-box;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.2-master-2026-06-10-2131/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'cdn:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);